/*
 * file:Utf8ToUtf16_2.c
 */
/** @file
 * @brief UTF-8  UTF-16 ւ̕ϊTvvOB
 * 
 * UTF-8  UTF-16 ւ̕ϊTvvÔQB(Windows APIgpȂ)
 * UTF-8ɂėpӂꂽ"data.txt"t@Cǂݍ݁A
 * UTF-16ւƕϊA
 * "out.txt"t@CւƏo͂܂B
 * t@C֏o͎ɂ́At@C̓2oCg̃f[^
 * 0xff 0xfe o͂܂B
 */
/* rbgp^[
 * 
 * tH[}bg  Unicode       UTF-8rbg                                         Unicoderbg                     
 * 
 * 1oCgR[h \u0`\u7f     0aaabbbb                                              00000000 0aaabbbb                   
 * 
 * 2oCgR[h \u80`\u7ff   110aaabb 10bbcccc                                     00000aaa bbbbcccc                   
 * 
 * 3oCgR[h \u800`\uffff 1110aaaa 10bbbbcc 10ccdddd                            aaaabbbb ccccdddd                   
 * 
 * 4oCgR[h --------------11110??? 10?????? 10?????? 10??????                   Ή                              
 * 
 * 5oCgR[h --------------111110?? 10?????? 10?????? 10?????? 10??????          Ή                              
 * 
 * 6oCgR[h --------------1111110? 10?????? 10?????? 10?????? 10?????? 10?????? Ή                              
 * 
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif
#define DEFAULT_BUFF_LEN 512

long min(long a, long b)
{
    long c;
    c = (a < b)?(a):(b);
    return c;
}

int Utf8ToUtf16(wchar_t *dest, size_t dest_size, char *src, size_t src_size);

int main(int argc, char *argv[])
{
    char    instr[DEFAULT_BUFF_LEN];
    wchar_t outstr[DEFAULT_BUFF_LEN];
    wchar_t bom;
    char    outbuffbom[4];
    FILE    *pFile;
    long    sizeFile;
    size_t  countRead;
    int     iResult = 0;
    int     instr_size = 0;
    
    /*
     * t@C蕶ǂݍ
     */
    memset(instr, 0, sizeof(instr));
    pFile = fopen("data.txt", "rb");
    if (pFile == NULL)
    {
        perror("t@CJ܂: data.txt");
        return 1;
    }
    fseek(pFile, 0, SEEK_END);
    sizeFile = ftell(pFile);
    fseek(pFile, 0, SEEK_SET);
    countRead = fread(instr, min(sizeFile, DEFAULT_BUFF_LEN), 1, pFile);
    fclose(pFile);
    if (countRead == 0)
    {
        perror("t@Cǂݍݎs: data.txt");
        return 1;
    }
    
    instr_size = min(sizeFile, DEFAULT_BUFF_LEN) * countRead;
    
    /*
     * utf8:instr -> utf16:outstr ϊB
     */
    memset(outstr, 0, sizeof(outstr));
    iResult = Utf8ToUtf16(outstr, sizeof(outstr), instr, instr_size);
    if (iResult == FALSE)
    {
        perror("Utf8ToUtf16() Failed.\n");
        return 1;
    }
    printf("%d ϊ܂B\n", iResult);
    
    /*
     * t@Cɕ݁B
     */
    pFile = fopen("out.txt", "wb");
    if (pFile == NULL)
    {
        perror("t@CJ܂: out.txt");
        return 1;
    }
    bom = 0xfeff;
    memcpy(outbuffbom, &bom, sizeof(wchar_t));
    fwrite(outbuffbom, sizeof(wchar_t), 1, pFile);
    fwrite(outstr, iResult * 2, 1, pFile);
    fclose(pFile);
}

/**
 * R[hUTF-8UTF16ւƕϊB
 * 
 * @param[out] dest o͕UTF-16
 * @param[in]  dest_size dest̃TCY[hPʂŎw
 * @param[in]  src ͕UTF-8
 * @param[in]  src_size ͕̃oCg
 * 
 * @return ɂ͏o͕̕߂܂B
 *         dest_size 0w肵Å֐ĂяoƁAϊꂽ
 *         i[̂ɕKvdest̃TCY̕߂܂B
 *         ֐sꍇɂ́AFALSE߂܂B
 */
int Utf8ToUtf16(wchar_t *dest, size_t dest_size, char *src, size_t src_size)
{
    const int nMaxReadSize = 6;
    size_t    countNeedsWords;
    size_t    cursor;
    char      chBuffer[nMaxReadSize];
    size_t    nReadDataSize;
    int       iCh1;
    int       sizeBytes;
    wchar_t   wcWork1, wcWork2, wcWork3;
    
    /*
     * ̓p[^`FbN
     */
    if (dest_size == 0)
    {
        /* dest_size == 0 */
    }
    else
    {
        /* dest_size != 0 */
        if (dest == NULL)
        {
            /* Error -- Null Pointer Exception : dest */
            return FALSE;
        }
        if (dest_size < 0)
        {
            /* Error -- dest_size < 0 */
            return FALSE;
        }
    }
    if (src == NULL)
    {
        /* Error -- Null Pointer Exception : src */
        return FALSE;
    }
    if (src_size < 1)
    {
        /* Error -- src_size < 1 */
        return FALSE;
    }
    
    /*
     * BOM̏
     */
    if ((*src == '\xef') && (*(src + 1) == '\xbb') && (*(src + 2) == '\xbf'))
    {
        /*
         * UTF-8BOMef bb bf
         * LE  BE ݂Ȃ̂ŁABOMt̏ꍇɂ͏B
         * BOMꍇ͂̂܂܏B
         */
        /* BOMꍇɂBOM𖳎 */
        src += 3;
    }
    
    countNeedsWords = 0;
    for (cursor = 0; cursor < src_size;)
    {
        /* src6oCg̃f[^ǂݏo */
        nReadDataSize = (nMaxReadSize < (src_size - cursor))?(nMaxReadSize):(src_size - cursor);
        memcpy(chBuffer, (src + cursor), nReadDataSize);
        memset(chBuffer + nReadDataSize, 0, sizeof(chBuffer) - nReadDataSize);

        /* data size ׂ̒ */
        iCh1 = ((int)(*chBuffer)) & 0x00ff;
        iCh1 = ~iCh1;   /* rbg] */
        if (iCh1 & 0x0080)
        {
            /* 0aaabbbb */
            sizeBytes = 1;
        }
        else if (iCh1 & 0x0040)
        {
            /* error(ɏoĂ͂ȂR[h) */
            return FALSE;
        }
        else if (iCh1 & 0x0020)
        {
            /* 110aaabb 10bbcccc */
            sizeBytes = 2;
        }
        else if (iCh1 & 0x0010)
        {
            /* 1110aaaa 10bbbbcc 10ccdddd */
            sizeBytes = 3;
        }
        else if (iCh1 & 0x0008)
        {
            /* Ή̃}bsO(UTF-16ɑ݂ȂR[h) */
            sizeBytes = 4;
        }
        else if (iCh1 & 0x0004)
        {
            /* Ή̃}bsO(UTF-16ɑ݂ȂR[h) */
            sizeBytes = 5;
        }
        else if (iCh1 & 0x0002)
        {
            /* Ή̃}bsO(UTF-16ɑ݂ȂR[h) */
            sizeBytes = 6;
        }
        else
        {
            /* error(ɏoĂ͂ȂR[h) */
            return FALSE;
        }
        
        /*
         * dest_size `FbN
         */
        if (dest_size && (dest_size < (countNeedsWords + 1)))
        {
            /* Error : memory is not enough for dest */
            return countNeedsWords;
        }
        
        /* sizeBytesɏ𕪊 */
        if (dest_size) switch (sizeBytes)
        {
        case 1:
            /*
             * rbg
             * (0aaabbbb)UTF-8 ... (00000000 0aaabbbb)UTF-16
             */
            *dest = ((wchar_t)(chBuffer[0])) & (wchar_t)0x00ff;     /* 00000000 0aaabbbb */
            dest++;
            break;
        case 2:
            /*
             * rbg
             * (110aaabb 10bbcccc)UTF-8 ... (00000aaa bbbbcccc)UTF-16
             */
            wcWork1 = ((wchar_t)(chBuffer[0])) & (wchar_t)0x00ff;   /* 00000000 110aaabb */
            wcWork2 = ((wchar_t)(chBuffer[1])) & (wchar_t)0x00ff;   /* 00000000 10bbcccc */
            wcWork1 <<= 6;                                          /* 00110aaa bb?????? */
            wcWork1 &= 0x07c0;                                      /* 00000aaa bb000000 */
            wcWork2 &= 0x003f;                                      /* 00000000 00bbcccc */
            *dest = wcWork1 | wcWork2;                              /* 00000aaa bbbbcccc */
            dest++;
            break;
        case 3:
            /*
             * rbg
             * (1110aaaa 10bbbbcc 10ccdddd)UTF-8 ... (aaaabbbb ccccdddd)UTF-16
             */
            wcWork1 = ((wchar_t)(chBuffer[0])) & (wchar_t)0x00ff;   /* 00000000 1110aaaa */
            wcWork2 = ((wchar_t)(chBuffer[1])) & (wchar_t)0x00ff;   /* 00000000 10bbbbcc */
            wcWork3 = ((wchar_t)(chBuffer[2])) & (wchar_t)0x00ff;   /* 00000000 10ccdddd */
            wcWork1 <<= 12;                                         /* aaaa???? ???????? */
            wcWork1 &= 0xf000;                                      /* aaaa0000 00000000 */
            wcWork2 <<= 6;                                          /* 0010bbbb cc?????? */
            wcWork2 &= 0x0fc0;                                      /* 0000bbbb cc000000 */
            wcWork3 &= 0x003f;                                      /* 00000000 00ccdddd */
            *dest = wcWork1 | wcWork2 | wcWork3;                    /* aaaabbbb ccccdddd */
            dest++;
            break;
        case 4:
        case 5:
        case 6:
        default:
            /* _~[f[^(uff1f)o */
            *dest = (wchar_t)0xff1f;
            dest++;
            break;
        }
        countNeedsWords++;
        cursor += sizeBytes;
    }
    
    return countNeedsWords;
}
